#! /usr/bin/env python3
# -*- coding: utf-8 -*-
#
# Dieses Dokument ist in der Zusammenarbeit von Informatikreferendaren und
# ehemaligen Informatikreferendaren der Studienseminare (heute ZfsL) Arnsberg,
# Hamm und Solingen entstanden.
#
# Das Dokument steht unter der Lizenz: Creative Commons by-nc-sa Version 4.0
# http://creativecommons.org/licenses/by-nc-sa/4.0/deed.de
#
# Nach dieser Lizenz darf das Dokument beliebig kopiert und bearbeitet werden,
# sofern das Folgeprodukt wiederum unter gleichen Lizenzbedingungen vertrieben
# und auf die ursprünglichen Urheber verwiesen wird.
# Eine kommerzielle Nutzung ist ausdrücklich ausgeschlossen.
#
# Die Namensnennung durch einen Verweis und die Lizenzangabe der ursprünglichen
# Urheber auf den Materialien für Schülerinnen und Schüler ist erforderlich.
#
# Die Sammlung der Dokumente steht unter
# http://ddi.uni-wuppertal.de/material/materialsammlung/
# zur Verfügung.
#
# Weitere Lizenz: GPL V3.0
# Siehe http://www.gnu.org/licenses/gpl-3.0.html
#
# $Id: tabellensortierer.py 1213 2015-05-12 15:04:03Z humbert $

from datenstrukturen import Liste 


def sortIn(listeEinAus):
    """Sortierung nach zwei Kriterien: Anzahl Siege und folgend Anzahl Punkte"""
    def key1(te): return -te.siege
    def key2(te): return -te.punkteErzielt
    listeEinAus.sort(key=key2) 
    listeEinAus.sort(key=key1) 


class TabellenSortierer:
    __module__ = __name__

    def sortiere(self, eintraege): # eintraege: Objekt der Klasse Liste
        liste = list() # Objekt der eingebauten Standardklasse
        zaehler = 0
        while zaehler < eintraege.gibLaenge():
            liste.append(eintraege.gibElementAnPosition(zaehler))
            zaehler = zaehler + 1

        sortIn(self.eintraege)  # mit der oben angegebenen Sortierfunktion
        eintraege = Liste()
        for e in liste:
            eintraege.haengeAn(e)

        return eintraege



# [Selbst-]Test der Funktionalitaeten
if __name__ == "__main__":
    print ("[Selbst-]Test der Funktionalität[en] - tabellensortierer.py - todo")
    


